import java.util.Enumeration;

import scg.ac.ni.pmf.newgraph.graphdata.GraphData;
import scg.ac.ni.pmf.newgraph.graphdata.VertexData;
import scg.ac.ni.pmf.newgraph.invariants.InvariantInt;

public class OrderOneInvariant implements InvariantInt {

	public String getName() {
		return "Order one";
	}

	public String getDescription() {
		return "The number of vertices of the degree one.";
	}
	
	public int calculate(GraphData data) {
		int n = 0;
		for(Enumeration i = data.vertices(); i.hasMoreElements(); ) {
			VertexData vertex = (VertexData) i.nextElement();
			if(vertex.degree() == 1)
				n++;
		}
		return n;
	}

}
