import java.util.*;
import scg.ac.ni.pmf.newgraph.action.GraphAction;
import scg.ac.ni.pmf.newgraph.graphdata.Graph;
import scg.ac.ni.pmf.newgraph.graphdata.GraphData;
import scg.ac.ni.pmf.newgraph.graphdata.Vertex;

public class BFSTree implements GraphAction {

        public String getName() {
                return "BFS tree";
        }

        public String getDescription() {
                return "Constructs the BFS tree.";
        }

        public boolean isEnabled(GraphData graph) {
                if (graph.getPrimarySelectedVertex()!=null)
                    return true;
                else
                    return false;
        }

        public void action(Graph graph, boolean ctrl, boolean shift) {
                BFS(graph, graph.getPrimarySelectedVertex().getID());
        }
        
        public void BFS(Graph graph, int s) {
                int n = graph.getOrder();
                int[] color = new int[n+1];
                int[] distance = new int[n+1];
                int[] parent = new int[n+1];

                for (int i = 1; i<=n; i++) {
                    color[i] = 0;
                    distance[i] = -1;
                    parent[i] = -1;
                }

                color[s] = 1;
                distance[s] = 0;
                parent[s] = -1;          

                Queue q = new Queue(n);
                q.enqueue(s);
                while (!q.isEmpty()) {
                    int u = q.dequeue();
                    for (int v=1; v<=n; v++) {
                         if (graph.isAdjanced(u,v))
                         if (color[v]==0) {
                             color[v]=1;
                             distance[v] = distance[u]+1;
                             parent[v]=u;
                             q.enqueue(v);
                         }
                    }
                    color[u]=2;
                }

            Vector tree = new Vector();
            tree.add(graph.getVertex(s));
            for (int i=1; i<=n; i++) {
                if (parent[i]!=-1) {
                    tree.add(graph.getEdge(i, parent[i]));
                    tree.add(graph.getVertex(i));
                }
            }
            graph.setSelection(tree);
        }
}        