import java.util.*;
import scg.ac.ni.pmf.newgraph.generator.GraphGenerator;
import scg.ac.ni.pmf.newgraph.graphdata.*;
import scg.ac.ni.pmf.newgraph.param.Parametrizable;

public class RandomGraph implements GraphGenerator, Parametrizable {

        public String getName() {
                return "Random graph";
        }

        public String getDescription() {
                return "Creates a random graph with given edge probability.";
        }

        public void newGraph(Graph graph) {
                double r = 200;
                for (int i=0; i<n; i++)
                try {
                    graph.createVertex (i, r*Math.sin(2*Math.PI*i/n),
                                           r*Math.cos(2*Math.PI*i/n), "" + i);
                }
                catch (Exception e) {}
                                   
                Random rnd = new Random();
                for (int i = 0; i<n; i++) {
                     for (int j = i+1; j<n; j++ ) {
                         if (rnd.nextDouble() < prob)
                             graph.createEdge(i, j);
                     }
                }                
        }
        
        private int n;
        public int getN () {
                return n;
        }
        public void setN(int n) {
                this.n = n;
        }
        
        private double prob;   
        public double getProb() {
                return prob;
        }
        public void setProb(double prob) {
                this.prob = prob;
        }

        public String checkParameters() {
                if (n<1)
                    return "The number of vertices must be at least 1.";
                
                if (prob<-0.00000001 || prob>1.00000001)
                    return "Edge probability must be between 0.0 and 1.0.";
                
                return null;
        }
}