import java.util.*;
import scg.ac.ni.pmf.newgraph.action.GraphAction;
import scg.ac.ni.pmf.newgraph.graphdata.Graph;
import scg.ac.ni.pmf.newgraph.graphdata.GraphData;
import scg.ac.ni.pmf.newgraph.graphdata.Vertex;

public class SpringAlgorithm implements GraphAction {

        public String getName() {
                return "Spring algorithm";
        }

        public String getDescription() {
                return "Visually separates the connected components.";
        }

        public boolean isEnabled(GraphData graph) {
                return true;
        }

        public void action(Graph graph, boolean ctrl, boolean shift) {
           graph.create(graph.adjacencyMatrix());
        }

        int n, time;
        int[] color;
        int[] parent;
        int[] component;
        
        public void DFS(Graph graph) {
                n = graph.getOrder();
                color = new int[n+1];
                parent = new int[n+1];
                component = new int[n+1];

                for (int i = 1; i<=n; i++) {
                    color[i] = 0;
                    parent[i] = -1;
                }

                time = 0;
                for (int i = 1; i<=n; i++) {
                    if (color[i]==0) {
                        time++;
                        DFSvisit(graph, i);
                    }
                }
                
                float minx = graph.getVertex(1).getX();
                float maxx = graph.getVertex(1).getX();
                for (int i=2; i<=n; i++) {
                    float curx = graph.getVertex(i).getX();
                    if (curx < minx) minx = curx;
                    if (maxx < curx) maxx = curx;
                }
                float width = (float) 1.15*(maxx - minx);
                
                for (int i=1; i<=n; i++) {
                    Vertex vi = graph.getVertex(i);
                    vi.moveTo(vi.getX() + (component[i]-1)*width, vi.getY());
                }
        }
        
        public void DFSvisit(Graph graph, int u) {
                color[u] = 1;
                component[u] = time;

                for (int v=1; v<=n; v++) {
                    if (graph.isAdjanced(u,v))
                    if (color[v]==0) {
                        parent[v] = u;
                        DFSvisit(graph, v);
                    }
                }

                color[u] = 2;
        }        
}
