import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;

import scg.ac.ni.pmf.newgraph.graphdata.Graph;
import scg.ac.ni.pmf.newgraph.graphdata.GraphData;
import scg.ac.ni.pmf.newgraph.graphdata.Vertex;
import scg.ac.ni.pmf.newgraph.graphdata.VertexData;
import scg.ac.ni.pmf.newgraph.dependency.Dependency;
import scg.ac.ni.pmf.newgraph.param.Parametrizable;
  
public class SquareGraph implements Dependency, Parametrizable 
{
        public String getName()
        {
            return "Square graph";
        }
        
        public String getDescription()
        {
            return "Creates a square graph.";
        }
        
        public void create(Graph graph)
        {
            // copy the vertices
            Map oldToNewVertices = new HashMap();
            for (Enumeration i = source.vertices(); i.hasMoreElements(); ) {
                VertexData u = (VertexData) i.nextElement();
                Vertex w = graph.createVertex(u.getX(), u.getY());
                oldToNewVertices.put(u,w);
            }
            
/* GENERAL APPROACH THAT DOES NOT WORK BECAUSE OF IMPROPER USE OF DISTANCES?! */
            // find the distance matrix
            int[][] distances = source.distances();
            
            // create the edges
            for (Enumeration i = source.vertices(); i.hasMoreElements(); ) {
                VertexData u = (VertexData) i.nextElement();
                for (Enumeration j = source.vertices(); j.hasMoreElements(); ) {
                    VertexData v = (VertexData) j.nextElement();
                    int d = distances[source.getIndex(u)][source.getIndex(v)];
                    if ((d==1)||(d==2))
                        graph.createEdge((Vertex) oldToNewVertices.get(u),
                                         (Vertex) oldToNewVertices.get(v));
                }
            }
/* */            

/* PARTICULAR APPROACH THAT MIGHT NOT BE THE MOST ELEGANT, BUT WORKS :-)
            // create the edges
            for (Enumeration i = source.vertices(); i.hasMoreElements(); ) {
                VertexData u = (VertexData) i.nextElement();
                for (Enumeration j = u.getNeighbors(); j.hasMoreElements(); ) {
                    VertexData v = (VertexData) j.nextElement();
                    graph.createEdge((Vertex) oldToNewVertices.get(u),
                                     (Vertex) oldToNewVertices.get(v));
                    for (Enumeration k = u.getNeighbors(); k.hasMoreElements(); ) {
                        VertexData w = (VertexData) k.nextElement();
                        if (v.getID() != w.getID())
                            graph.createEdge((Vertex) oldToNewVertices.get(v),
                                             (Vertex) oldToNewVertices.get(w));
                    }
                }
            }
*/
        }

        public String checkParameters() 
        {
            return null;
        }

        private GraphData source;
        
        public GraphData getSource() {
                return source;
        }
        
        public void setSource(GraphData source) {
                this.source = source;
        }
        
}
