import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;

import scg.ac.ni.pmf.newgraph.graphdata.Graph;
import scg.ac.ni.pmf.newgraph.graphdata.GraphData;
import scg.ac.ni.pmf.newgraph.graphdata.Vertex;
import scg.ac.ni.pmf.newgraph.graphdata.VertexData;
import scg.ac.ni.pmf.newgraph.graphdata.EdgeData;
import scg.ac.ni.pmf.newgraph.invariants.InvariantIntVertex;
import scg.ac.ni.pmf.newgraph.invariants.VertexIntValues;
  
public class TrianglesContaining implements InvariantIntVertex
{
        public String getName()
        {
            return "Triangles containing";
        }
        
        public String getDescription()
        {
            return "Counts the number of triangles containing each vertex.";
        }
        
        public void calculate(GraphData data, VertexIntValues values)
        {
            for (Enumeration i = data.vertices(); i.hasMoreElements(); ) {
                VertexData u = (VertexData) i.nextElement();
                int t = 0;
                for (Enumeration j = data.edges(); j.hasMoreElements(); ) {
                    EdgeData e = (EdgeData) j.nextElement();
                    if (data.isAdjanced(u, (VertexData) e.getVertexA()) &&
                        data.isAdjanced(u, (VertexData) e.getVertexB())) {
                            t++;
                        }
                }
                values.assignValue(u, t);
            }
        }                
}
